.nolist
; 
include \masm32\include\masm32rt.inc
.686
include \masm32\macros\timers.asm
; 

SetSmallRect PROTO: DWORD, :DWORD, :DWORD, :DWORD, :DWORD
SetRect16 PROTO: DWORD, :WORD, :WORD, :WORD, :WORD
PopSmallRect PROTO: DWORD, :DWORD, :DWORD, :DWORD, :DWORD

SMALL_RECT STRUCT
  Left      WORD      ?
  Top       WORD      ?
  Right     WORD      ?
  Bottom    WORD      ?
SMALL_RECT ENDS

SmallRect MACRO ps_r, left, top, right, bottom	; usage: SmallRect 1, 2, 3, 4
    mov edx, ps_r
    push left
    pop dword ptr [edx].SMALL_RECT.Left
    push top
    pop dword ptr [edx].SMALL_RECT.Top
    push right
    pop dword ptr [edx].SMALL_RECT.Right
    push bottom
    pop word ptr [edx].SMALL_RECT.Bottom
    pop ax
ENDM

opsize MACRO arg
LOCAL LocArg
ifndef OpSizeDD
	.data?
	OpSizeDD	dd ?
	.code
	echo dd defined in opsize
endif
ArgType = (opattr(arg)) AND 127
tmp$ CATSTR <Type is >, %ArgType, < for >, <arg>
% echo tmp$
ifb <arg>
	echo IsBlank
	call @F
@@:	pop OpSizeDD  		;; contains EIP of pop instruction
elseif ArgType eq 37		;; procedure
	pushad
	plbl CATSTR <os>,<arg>
	print chr$(32)
	mov eax, offset plbl
	; % echo sub eax, offset <arg>
	sub eax, offset arg
	print str$(eax)
	tmp$ CATSTR <"bytes >, <arg>, < procedure">
	print chr$(9, tmp$, 13, 10)
	popad
else
	flag SUBSTR <arg>, 2,1
	ifidn flag, <:>
		LocArg CATSTR <">, @SubStr(<arg>, 3)
		LocLen SIZESTR LocArg
		LocIns SUBSTR LocArg, 2, LocLen-2
		tmp$ CATSTR <TheSize=>, %LocLen, <, Ins=>, LocIns
;		% echo tmp$
;		echo IsBlank
		call @F
@@:		pop OpSizeDD   ; contains EIP of pop instruction
		LocIns
;		echo we got a flag
;		% echo flag
;		% echo LocArg
;		.err
	else
		LocArg equ <arg>
		tmp$ CATSTR <TheOldArg=>, LocArg
		% echo tmp$
	endif
	echo IsNotBlank <arg>
	call @F
@@:	push eax
	mov eax, [esp+4]
	sub eax, 11
	sub OpSizeDD, eax   ; contains EIP of pop instruction
	neg OpSizeDD
	pop eax
	add esp, 4
	pushad
	print chr$(13, 10, 32)
	print str$(OpSizeDD)
	print chr$(9, "bytes ", LocArg, 13, 10)
	; invoke MessageBox, 0, str$(OpSizeDD), chr$(LocArg), MB_OK
	popad
endif
ENDM

    .data?
 v1	dd ?
small_rect	SMALL_RECT <>
 v2	dd ?
rc 	RECT <>

; (3*27+19)-(3*33)=1
; (6*27+37)-(6*33)=1

    .code
; 
start:
; 
LoopCount	= 10000000
ShowOutput	= 1		; for testing if the code produces correct output
GoodOne	= 1		; for testing a stack alignment problem in PopSmallRect

mov v1, 12345678	; testing for
mov v2, 87654321	; boundary violation
; int 3
mov eax, eax
opsize
    invoke SetSmallRect, ADDR small_rect, 101, 201, 301, 401		; call plus 35 bytes
opsize "SetSmallRect call"
opsize SetSmallRect
print chr$(32)
; int 3
mov ebx, ebx
invoke Sleep, 500
counter_begin LoopCount, HIGH_PRIORITY_CLASS
    invoke SetSmallRect, ADDR small_rect, 101, 201, 301, 401
counter_end
print str$(eax), 9, "cycles", 13,10, 10
; int 3
mov ecx, ecx
if ShowOutput
    movzx eax, small_rect.Left
    print ustr$(eax),13,10
    movzx eax, small_rect.Top
    print ustr$(eax),13,10
    movzx eax, small_rect.Right
    print ustr$(eax),13,10
    movzx eax, small_rect.Bottom
    print ustr$(eax),13,10, 10
endif
; int 3
mov edx, edx

opsize
    invoke SetRect16, ADDR small_rect, 101, 201, 301, 401		; call plus 35 bytes
opsize "SetRect16 call"
opsize SetRect16
print chr$(32)
invoke Sleep, 500
counter_begin LoopCount, HIGH_PRIORITY_CLASS
    invoke SetRect16, ADDR small_rect, 101, 201, 301, 401
counter_end
print str$(eax), 9, "cycles", 13,10, 10
if ShowOutput	; 
    movzx eax, small_rect.Left
    print ustr$(eax),13,10
    movzx eax, small_rect.Top
    print ustr$(eax),13,10
    movzx eax, small_rect.Right
    print ustr$(eax),13,10
    movzx eax, small_rect.Bottom
    print ustr$(eax),13,10, 10
endif
; int 3
mov esi, esi


if 1
; the macro version
opsize
    SmallRect offset small_rect, 102, 202, 302, 402		; call plus 35 bytes
opsize "SmallRect macro"

print chr$(32)
counter_begin LoopCount, HIGH_PRIORITY_CLASS
    SmallRect offset small_rect, 102, 202, 302, 402
counter_end
print str$(eax), 9, "cycles", 13,10, 10
if ShowOutput
    movzx eax, small_rect.Left
    print ustr$(eax),13,10
    movzx eax, small_rect.Top
    print ustr$(eax),13,10
    movzx eax, small_rect.Right
    print ustr$(eax),13,10
    movzx eax, small_rect.Bottom
    print ustr$(eax),13,10, 10
endif
; int 3
mov edi, edi
endif

if 1
opsize
    invoke PopSmallRect, ADDR small_rect, 103, 203, 303, 403		; call plus 19 bytes
opsize "PopSmallRect call"
opsize PopSmallRect

print chr$(32)
invoke Sleep, 500
counter_begin LoopCount, HIGH_PRIORITY_CLASS
    invoke PopSmallRect, ADDR small_rect, 103, 203, 303, 403
counter_end
print str$(eax), 9, "cycles", 13,10, 10
if ShowOutput
    movzx eax, small_rect.Left
    print ustr$(eax),13,10
    movzx eax, small_rect.Top
    print ustr$(eax),13,10
    movzx eax, small_rect.Right
    print ustr$(eax),13,10
    movzx eax, small_rect.Bottom
    print ustr$(eax),13,10
endif
endif

; int 3
mov eax, eax

print chr$(13, 10, 32, "??",9,"bytes WinApi SetRect", 13, 10, 32)
counter_begin LoopCount, HIGH_PRIORITY_CLASS
    invoke SetRect, ADDR rc, 104, 204, 304, 404
counter_end
print str$(eax), 9, "cycles", 13,10, 10
if ShowOutput
    mov eax, rc.left
    print ustr$(eax),13,10
    mov eax, rc.top
    print ustr$(eax),13,10
    mov eax, rc.right
    print ustr$(eax),13,10
    mov eax, rc.bottom
    print ustr$(eax),13,10
endif
; int 3
mov ebx, ebx

mov eax, v1
sub eax, 12345678
.if eax
	print chr$(13, 10, "Upper boundary broken!", 13, 10, 10)
.endif
mov eax, v2
sub eax, 87654321
.if eax
	print chr$(13, 10, "Lower boundary broken!", 13, 10, 10)
.endif

    inkey "Press any key to exit..."

; MsgBox 0, chr$("Done."), chr$("SmallRect"), MB_OK

    exit
; 

SetSmallRect proc ps_r:DWORD,left:DWORD,top:DWORD,right:DWORD,bottom:DWORD
    mov edx, ps_r
    mov eax, left
    mov [edx].SMALL_RECT.Left, ax
    mov eax, top
    mov [edx].SMALL_RECT.Top, ax
    mov eax, right
    mov [edx].SMALL_RECT.Right, ax
    mov eax, bottom
    mov [edx].SMALL_RECT.Bottom, ax
    ret
SetSmallRect endp
osSetSmallRect:

SetRect16 proc ps_r:DWORD,left:WORD,top:WORD,right:WORD,bottom:WORD
    mov edx, ps_r
    mov ax, left
    mov [edx].SMALL_RECT.Left, ax
    mov ax, top
    mov [edx].SMALL_RECT.Top, ax
    mov ax, right
    mov [edx].SMALL_RECT.Right, ax
    mov ax, bottom
    mov [edx].SMALL_RECT.Bottom, ax
    ret
SetRect16 endp
osSetRect16:

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
PopSmallRect proc ps_r:DWORD,left:DWORD,top:DWORD,right:DWORD,bottom:DWORD
	pop edx		; trash the return address
	pop edx		; move the first argument to edx
	pop dword ptr [edx].SMALL_RECT.Left
	pop dword ptr [edx].SMALL_RECT.Top
	pop dword ptr [edx].SMALL_RECT.Right
	if GoodOne
		pop word ptr [edx].SMALL_RECT.Bottom
		sub esp, 6*4-2	; correct for 5 dword and one word pop
	else
		pop dword ptr [edx].SMALL_RECT.Bottom		; this version overwrites the word below the structure
		sub esp, 6*4	; correct for 6 pops
	endif
	ret 5*4			; correct stack for five arguments
PopSmallRect endp
osPopSmallRect:
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

end start
OPT_Tmp2Asm	1
OPT_Linker	polink
OPT_icon	house
OPT_WAIT	0
